import matplotlib.pyplot as plt

from ...Time import Time

class CurrentLeadsPlot(object):

    @staticmethod
    def plot_leads_voltage(u_leads_odd_df, u_leads_even_df, timestamp_fgc_act, circuit_name):
        title = '{} {}: U_HTS and U_RES for LEADS_ODD and LEADS_EVEN'.format(Time.convertToString(timestamp_fgc_act)[:23], circuit_name)
        ax1 = u_leads_odd_df.filter(regex='U_RES').plot(title=title, figsize = (15, 7.5))
        u_leads_even_df.filter(regex='U_RES').plot(ax=ax1, grid=True)

        ax1.title.set_size(20)
        ax1.set_xlabel("time, [s]", fontsize=15)
        ax1.legend(loc='lower left')
        ax1.set_ylabel("U_RES, [V]", fontsize=15)
        ax1.tick_params(labelsize=15)

        ax2 = ax1.twinx()
        u_leads_odd_df.filter(regex='U_HTS').plot(ax=ax2)
        u_leads_even_df.filter(regex='U_HTS').plot(ax=ax2)
        ax2.legend(loc='upper right')
        ax2.set_ylabel("U_HTS, [V]", fontsize=15)
        ax2.tick_params(labelsize=15)
        plt.show()