import matplotlib.pyplot as plt
from lhcsmapi.Time import Time

from lhcsmapi.analysis.qds.iqds.IqdsPlot import IqdsPlot
from lhcsmapi.analysis.qds.nqds.NqdsPlot import NqdsPlot


class QdsPlot(object):

    @staticmethod
    def plot_iqds_nqds(source_qds, timestamp_qds, u_qds_df, timestamp_pic, timestamp_nqps, t_start_quench, t_ST_NQD0,
                       t_ST_MAGNET_OK, u_nqps_df, st_nqps_df, circuit_name, i_quench):
        # # iQPS
        title = "Magnet: {}, Time Stamp: {}, Current = {} A".format(source_qds,
                                                                    Time.convertToString(timestamp_qds)[:23], i_quench)
        fig = plt.figure(figsize=(25, 15))
        fig, ax = plt.subplots(2, 2, figsize=(30, 15))
        fig.suptitle(title, fontsize=20)

        IqdsPlot.plot_u_qds(u_qds_df, timestamp_qds, timestamp_pic, title=title, xmin=t_start_quench, xmax=t_ST_NQD0,
                            xlim=(t_start_quench - 0.025, t_ST_MAGNET_OK + 0.075), ax=ax[0, 0])
        IqdsPlot.plot_st_qds(u_qds_df, xmin=t_start_quench, xmax=t_ST_NQD0, title=title,
                             xlim=(t_start_quench - 0.025, t_ST_MAGNET_OK + 0.075), ax=ax[1, 0])

        # # nQPS
        if abs(timestamp_nqps - timestamp_qds) < 2e9:
            if st_nqps_df is not None:
                NqdsPlot.plot_u_diode_st_magnet_ok_pm_nqds(u_nqps_df, st_nqps_df, timestamp_nqps, circuit_name,
                                                           ax=ax[0, 1])
            else:
                NqdsPlot.plot_u_diode_cals_nqds(u_nqps_df, timestamp_nqps, circuit_name, ax=ax[0, 1])
        else:
            NqdsPlot.plot_u_diode_cals_nqds(u_nqps_df, timestamp_nqps, circuit_name, ax=ax[0, 1])

        ax[1, 1].axis('off')
        plt.show()