import matplotlib.pyplot as plt

from ....Time import Time


class NqdsPlot(object):

    @staticmethod
    def plot_u_diode_st_magnet_ok_pm_nqds(u_nqps_df, st_nqps_df, timestamp_nqps, circuit_name, ax=None):
        title = '{} {} U_DIODE_RB(t) and ST_MAGNET_OK_SQRB(t) - PM'.format(Time.convertToString(timestamp_nqps)[:23],
                                                                           circuit_name)
        if ax != None:
            ax1 = u_nqps_df.plot(ax=ax, title='nQPS', grid=True)
        else:
            ax1 = u_nqps_df.plot(figsize=(15, 7), title=title, grid=True)

        ax1.title.set_size(20)
        ax1.legend(loc='lower left')
        ax1.set_xlabel("time, [s]", fontsize=15)
        ax1.set_ylabel("U_DIODE_RB, [V]", fontsize=15)
        ax1.tick_params(labelsize=15)

        ax2 = ax1.twinx()
        st_nqps_df.astype(int).plot(ax=ax2)
        ax2.legend(loc='upper right')
        ax2.set_ylabel("ST_MAGNET_OK_SQRB, [-]", fontsize=15)
        ax2.tick_params(labelsize=15)

        if ax == None:
            plt.show()

    @staticmethod
    def plot_u_diode_cals_nqds(u_nqps_df, timestamp_nqps, circuit_name, ax=None):
        title = '{} {} U_DIODE_RB(t) - CALS'.format(Time.convertToString(timestamp_nqps)[:23], circuit_name)

        if ax != None:
            ax1 = u_nqps_df.plot(ax=ax, title='nQPS', grid=True)
        else:
            ax1 = u_nqps_df.plot(figsize=(15, 7), title=title)

        ax1.title.set_size(20)
        ax1.legend(loc='lower left')
        ax1.set_xlabel("time, [s]", fontsize=15)
        ax1.set_ylabel("U_DIODE_RB, [V]", fontsize=15)
        ax1.tick_params(labelsize=15)

        if ax is None:
            plt.show()
