import os
import pandas as pd

class Reference(object):

    @staticmethod
    def getQuenchHeaterReferenceDischarges():
        selected_path = os.path.dirname(__file__)
        full_path = os.path.join(selected_path, 'qh/ReferenceDischarges.csv')
        return pd.read_csv(full_path, index_col=0)

    @staticmethod
    def getEnergyExtractionReferenceTemperature():
        selectedPath = os.path.dirname(__file__)
        fullPath = os.path.join(selectedPath, 'ee/refTemperatureEE.csv')
        return pd.read_csv(fullPath, index_col=0)

    @staticmethod
    def getPowerConverterReferenceFpa():
        selectedPath = os.path.dirname(__file__)
        fullPath = os.path.join(selectedPath, 'pc/rbReference_PNO_b2.csv')
        return pd.read_csv(fullPath)

    @staticmethod
    def findQhTimestampForMagnetNameFromReference(qhReferenceDischarges, magnet):
        # Look for the reference curve timestamp
        if not qhReferenceDischarges[qhReferenceDischarges['magnetName'] == magnet].empty:
            return qhReferenceDischarges[qhReferenceDischarges['magnetName'] == magnet]['timestamp'].values[0]
        else:
            return -1
